recursive function binsearch(ii,n,v) result(ipos)
!-----------------------------------------------------------------
! Versione ricorsiva della function che cerca la posizione del
! valore ii all'interno di un vettore intero ordinato utilizzando
! una ricerca binaria.
! Se il valore ii non e' presente, allora ipos assume valore nullo
!-----------------------------------------------------------------

implicit none

integer, intent(in) :: ii,n,v(n)
integer             :: ipos
integer             :: istart,iend,imid,nsub,itmp

! Inizializzazione
ipos = 0

if (n .le. 2) then

   ! Base: intervallo di dimensione minore o uguale a 2
   if (v(1) .eq. ii) ipos = 1
   if ( (n .eq. 2) .and. (v(2) .eq. ii) ) ipos = 2

else

   ! Ricorsione:
   istart = 1
   iend = n
   ! Controlla di non essere fuori dall'intervallo
   if ((ii .lt. v(istart)) .or. (ii .gt. v(iend)) ) return

   ! Controlla in quale meta' si potrebbe trovare ii
   imid = (istart + iend) / 2
   if (v(imid) .gt. ii) then
      iend = imid
   else
      istart = imid
   endif

   ! Cerca nel nuovo sotto-intervallo
   nsub = iend - istart + 1
   itmp = binsearch(ii,nsub,v(istart:iend))
   ! Se itmp e' diverso da zero allora ho trovato il punto che mi interessa
   if (itmp .ne. 0) then
      ipos = istart - 1 + itmp
   endif

endif

end function binsearch
